﻿Imports System.Configuration
Imports workear.workWearDS
Imports System.Data
Public Class NeueKleidung

   Dim mitarbeiterID As Int32
   Dim barCode As String = ""
   Dim Farbe As String = ""
   Dim TypID As Int32
   Dim size As String

   Shadows Focus As Boolean = False
   Dim dss As workWearDS
   Dim kleidNr As Int32
   Private _sqlp As SqlPersistance
   Private ABKleidungForm As Arbeitskleidung

   Public Sub New(ByRef ds As workWearDS, sqlp As SqlPersistance, ByRef formmm As Arbeitskleidung)

      ' Dieser Aufruf ist für den Designer erforderlich.
      InitializeComponent()
      dss = ds
      _sqlp = sqlp
      ABKleidungForm = formmm
      ' Fügen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
      laden(ds)

   End Sub


   'ByRef -> Wir wollen die Referenz übergeben damit wir in den Funktionen und der Instanz operieren können
   Public Sub laden(ByRef ds As workWearDS)
      'Aus dem DataSet alle Mitarbeiter auslesen. Felder lassen sich in der Sicht auf dem SQL-Server anpassen.
      Try

         'Mitarbeiterauswahl füllen.
         'Die Ansicht kommt vom SQL-Server.
         mitarbeitercmb.ItemsSource = dss.Tables("MitarbeiterFULL").DefaultView
         mitarbeitercmb.DisplayMemberPath = "FullName"
         'ID Hinter den Eintrag legen
         mitarbeitercmb.SelectedValuePath = "Id"



         'Typen auswahl definieren
         typcmb.ItemsSource = dss.Tables("typ").DefaultView
         typcmb.DisplayMemberPath = "Typ"
         typcmb.SelectedValuePath = "typID"



      Catch ex As Exception
         Funktionen.writeLog(ex)
         MessageBox.Show("Fehler beim laden der Werte")
      End Try





   End Sub


   Private Sub mitarbeitercmbAuswahl(sender As Object, e As SelectionChangedEventArgs) Handles mitarbeitercmb.SelectionChanged
      Try
         'Mitarbeiter ID ermitteln
         mitarbeiterID = Convert.ToInt32(CType(sender, ComboBox).SelectedValue.ToString())
         'TypID ermitteln

      Catch ex As Exception
         Funktionen.writeLog(ex)
         MessageBox.Show("Fehler beim ermitteln der Mitarbeiter-ID")
      End Try



   End Sub

   Private Sub brtxt_GotFocus(sender As Object, e As RoutedEventArgs) Handles brtxt.GotFocus
      'Focus auf den BarCode
      Try
         If (Focus = False) Then
            brtxt.Text = ""
            Focus = True
         End If
      Catch ex As Exception
         MessageBox.Show("Fehler in der Focusprozedur")
         Funktionen.writeLog(ex)
      End Try

   End Sub
   'schließen
   Private Sub clsbtn_Click(sender As Object, e As RoutedEventArgs) Handles clsbtn.Click
      'Nachfrage
      Dim res As New MessageBoxResult()
      res = MessageBox.Show("Wirklich beenden?", "Beenden", MessageBoxButton.OKCancel)
      If (res = MessageBoxResult.OK) Then
         Me.Close()
      Else

      End If

   End Sub
   'Speichern
   Private Sub sfbtn_Click(sender As Object, e As RoutedEventArgs) Handles sfbtn.Click
      Try
         Try
            'Falls der Barcode Zeichen enthält (Ist später der Primärschlüssel)
            kleidNr = Convert.ToInt32(brtxt.Text)
         Catch ex As Exception
            MessageBox.Show("Barcode enthält nicht nur Zahlen", "Fehler im Barcode")
            Funktionen.writeLog(ex)
            Exit Sub
         End Try

         'Datensatz in DataRows schreiben

         Dim neueKl As DataRow = dss.Tables("Kleidung").NewRow()
         Dim neueKlMit As DataRow = dss.Tables("mitarbeiter_kleidung").NewRow()

         'Kleidungstabelle füllen
         neueKl("kleidNr") = kleidNr
         neueKl("Farbe") = farbetxt.Text
         neueKl("size") = sizetxt.Text
         neueKl("Bemerkung") = bemerktxt.Text
         neueKl("Typ") = TypID

         dss.Tables("Kleidung").Rows.Add(neueKl)

         'Mitarbeiter->Kleidung Verbindung erstellen
         neueKlMit("mit") = mitarbeiterID
         neueKlMit("kleid") = kleidNr
         neueKlMit("erhalt") = Date.Now.ToString("MM/dd/yyyy HHH:mm:ss")

         dss.Tables("mitarbeiter_kleidung").Rows.Add(neueKlMit)
         'Speichern
         _sqlp.Save()

         MessageBox.Show("Schreiben abgeschlossen!")
         Me.Close()

      Catch ex As Exception
         Funktionen.writeLog(ex)
         MessageBox.Show("Fehler beim anlegen eines neuen Datensatzes" & ex.Message())
      End Try

   End Sub

   Private Sub typcmb_SelectionChanged(sender As Object, e As SelectionChangedEventArgs) Handles typcmb.SelectionChanged
      Try

         TypID = Convert.ToInt32(CType(sender, ComboBox).SelectedValue.ToString())

         'TypID ermitteln

      Catch ex As Exception
         Funktionen.writeLog(ex)
         MessageBox.Show("Fehler beim ermitteln der Typ-ID")
      End Try
   End Sub

   Private Sub Button_Click(sender As Object, e As RoutedEventArgs)
      Dim Vorname As DataRow = dss.Tables("Mitarbeiter").Rows.Find("2")
      If (Vorname IsNot Nothing) Then
         MessageBox.Show(Vorname(1).ToString())
      Else
         MessageBox.Show("Rip")
      End If
   End Sub

   Private Sub Window_Closing(sender As Object, e As ComponentModel.CancelEventArgs)



   End Sub
End Class



