﻿Option Strict On
Imports System.Security.Cryptography
Public Class password
#Region "Klasseneigenschaften"
    Private EncryptedString_ As String

#End Region
    Public Sub New()

    End Sub
#Region "Methoden"

    'Verschlüsselung
    Public Sub encrypt(ByVal AESKeySize As Int32, ByVal DecryptedString As String, ByVal Password As String)
        'Salt Wert definieren
        Dim Salt() As Byte = System.Text.Encoding.UTF8.GetBytes("repeat15!")

        'Hashwert generieren mithilfe des Passworts und dem Saltwert
        Dim _hashKey As New Rfc2898DeriveBytes(Password, Salt)

        'AES Objekt instanzieren mit 128 bit verschlüsselung
        Dim AES As New AesManaged
        AES.KeySize = AESKeySize
        AES.BlockSize = 128

        AES.Key = _hashKey.GetBytes(AES.KeySize \ 8)
        AES.IV = _hashKey.GetBytes(AES.BlockSize \ 8)

        Dim memoryStream As New IO.MemoryStream
        Dim cryptoStream As New CryptoStream(memoryStream, AES.CreateEncryptor(), CryptoStreamMode.Write)

        'Verschlüsseln
        Dim Data() As Byte
        Data = System.Text.Encoding.UTF8.GetBytes(DecryptedString)
        cryptoStream.Write(Data, 0, Data.Length)
        cryptoStream.FlushFinalBlock()
        cryptoStream.Close()

        'Verschlüsselter String ausgeben
        EncryptedString_ = Convert.ToBase64String(memoryStream.ToArray)
        memoryStream.Close()
        AES.Clear()
    End Sub


   

#End Region

#Region "Eigenschaften"
    ReadOnly Property EncryptedString() As String
        Get
            Return EncryptedString_
        End Get
    End Property
    
#End Region
End Class
